;----------------------------------------------------------------------------------------------------
; data section starts here
;----------------------------------------------------------------------------------------------------

	.data					

    
WAVE:	.word	1,3,10,3,1			
SPC1:	.space	64				

; input data are here 5 rows by 10 elements

LONG:	
    .word	0,0,1,0,1,0,0,0,0,0		
	.word	0,0,1,0,0,0,0,0,0,0
	.word	0,0,0,0,2,0,0,0,0,0
	.word	0,0,0,0,0,1,0,0,0,0
	.word	0,0,0,0,0,0,0,1,0,0

SPC2:	.space	64				


; result will go here
    
    .word   0xBBBBBBBB
RESULT:	
    .word	0,0,0,0,0,0,0,0,0,0		
	.word	0,0,0,0,0,0,0,0,0,0
	.word	0,0,0,0,0,0,0,0,0,0
	.word	0,0,0,0,0,0,0,0,0,0
	.word	0,0,0,0,0,0,0,0,0,0
    .word   0xEEEEEEEE

;----------------------------------------------------------------------------------------------------
; code-section starts here
;----------------------------------------------------------------------------------------------------
	.text					
	.global main

main:	
; load address of input data into R3
    lhi	    r3,LONG>>16
	ori	    r3,r0,LONG&0xFFFF
	
; load address of wave data into R4
	lhi	    r4,WAVE>>16
	ori     r4,r0,WAVE&0xFFFF

; load address of result into R5
	lhi	    r5,RESULT>>16
	ori	    r5,r0,RESULT&0xFFFF
	
; move in input data to the end since we process it from the end
; to the beginninng while wave is processed in reverse order.
	addi	r5,r5,49<<2
	
; initialize R9 and R15 with 49 and 4
	ori	    r9,r9,49
	ori	    r15,r15,4

; outer cycle for(outer=49; outer>=0; --outer)
outer:	


; zero R12 and set R7 to 4
    xor	r12,r12,r12
	ori	r7,r0,4			

; inner cycle for(inner=4; inner>=0; inner--)
; convolution core
inner:	

; count address in data and wave, perform load,
; multiplication and addition on them
    mult	r14,r7,r15
	add	    r6,r14,r4
	lw	    r8,0(r6)		
	mult    r31,r6,r8
	mult	r10,r9,r15		
	mult    r31,r10,r31
	sub	    r10,r10,r14		
	add	    r10,r10,r3
	lw	    r11,0(r10)
	mult	r13,r11,r8		
	add	    r12,r12,r13

; while not done, continue inner loop
	beqz	r7,next
	subi	r7,r7,1			
	j	    inner	

; shift to next data (we process them from end therefore
; the address has to be diminished by 4 (4 = sizeof(word))
next:	
    sw	    0(r5),r12
	subi	r5,r5,4
	beqz	r9,end
	subi	r9,r9,1
	j	    outer

; real end
end:	
    trap 0	