;----------------------------------------------------------------------------------------------------
; data section starts here
;----------------------------------------------------------------------------------------------------

	.data					

    
WAVE:	.word	1,3,10,3,1			
SPC1:	.space	64				

; input data are here 5 rows by 10 elements

LONG:	
    .word	0,0,1,0,1,0,0,0,0,0		
	.word	0,0,1,0,0,0,0,0,0,0
	.word	0,0,0,0,2,0,0,0,0,0
	.word	0,0,0,0,0,1,0,0,0,0
	.word	0,0,0,0,0,0,0,1,0,0

SPC2:	.space	64				

; result will go here
    
    .word   0xBBBBBBBB
RESULT:	
    .word	0,0,0,0,0,0,0,0,0,0		
	.word	0,0,0,0,0,0,0,0,0,0
	.word	0,0,0,0,0,0,0,0,0,0
	.word	0,0,0,0,0,0,0,0,0,0
	.word	0,0,0,0,0,0,0,0,0,0
    .word   0xEEEEEEEE

;----------------------------------------------------------------------------------------------------
; code-section starts here
;----------------------------------------------------------------------------------------------------
	.text					
	.global main

main:	
; load address of input data into R3
    lhi	    r3,LONG>>16
	ori	    r3,r0,LONG&0xFFFF
	
; load address of wave data into R4
	lhi	    r4,WAVE>>16
	ori     r4,r0,WAVE&0xFFFF

; load address of result into R5
	lhi	    r5,RESULT>>16
	ori	    r5,r0,RESULT&0xFFFF
	
; move in input data to the end since we process it from the end
; to the beginninng while wave is processed in reverse order.
	addi	r5,r5,49<<2
	
; initialize R9 and R15 with 49 and 4
	ori	r9,r9,49
	ori	r15,r15,4
	ori	r1,r0,16			

; outer cycle for(outer=49; outer>=0; --outer)

outer:	

; zero R12 and set R7 to 4
	xor	r12,r12,r12
	mult	r14,r9,r15		


; count address in data and wave, perform load,
; multiplication and addition on them
	add	r6,r1,r4
	lw	r8,0(r6)		
	sub	r10,r14,r1		
	add	r10,r10,r3
	lw	r11,0(r10)
	mult	r13,r11,r8		
	add	r12,r12,r13

	lw	r8,-4(r6)		
	addi	r10,r10,4
	lw	r11,0(r10)
	mult	r13,r11,r8		
	add	r12,r12,r13

	lw	r8,-8(r6)		
	addi	r10,r10,4
	lw	r11,0(r10)
	mult	r13,r11,r8		
	add	r12,r12,r13

	lw	r8,-12(r6)		
	addi	r10,r10,4
	lw	r11,0(r10)
	mult	r13,r11,r8		
	add	r12,r12,r13

	lw	r8,-16(r6)		
	addi	r10,r10,4
	lw	r11,0(r10)
	mult	r13,r11,r8		
	add	r12,r12,r13

; shift to next data (we process them from end therefore
; the address has to be diminished by 4 (4 = sizeof(word))
	sw	0(r5),r12
	subi	r5,r5,4
	beqz	r9,end
	subi	r9,r9,1
	j	outer

; real end
end:	
    trap 0	